#include	"YS274_EXIT_bitname.h"
/***********************************************************************************
;Company : Yspring ------л㴺Ƽɷ޹˾
;File Name :YS274
;Description :  YS274_AD_
***********************************************************************************/

#include <YS274.h>
#include "cfg.h"

// ˵
//			(1)	SLEEPWAKE_ENΪ0
//				PA5PC2PC3ⲿ̽ӲʽźŸPC2PC3
//				PC2׽½ʱᴥⲿж0жϺиıһPA2״̬PC3׽ʱᴥⲿж1жϺиıһPA4״̬
//
//			(2)	SLEEPWAKE_ENΪ1
//				ѭʱ˯
//				PC2׽½ʱᴥⲿж0˯߲жϺиıһPA2״̬PC3׽ʱᴥⲿж1жϺиıһPA4״̬

//-----------------------------------ض--------------------------------

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//-------------------------------------------------------------------------
void Init_GPIO(void);
void INT0_Init(void);
void INT1_Init(void);
void Sleep_Pro(void);

//------------------------------------궨--------------------------------------

#define CLRWDT()       \
	do                 \
	{                  \
		asm("clrwdt"); \
	} while (0)
#define SLEEP()       \
	do                \
	{                 \
		asm("sleep"); \
		asm("NOP");   \
		asm("NOP");   \
		;             \
	} while (0) // asm("clrwdt");asm("clrwdt")

#define SLEEPWAKE_EN 0 // 0ⲿź		1˯߻

//------------------------------------------------------------------------

//-----------------------------------λ---------------------------------------

/*********************************************************************************
;: main
;˵:	
*********************************************************************************/
void main(void)
{
#if SLEEPWAKE_EN
	unsigned int i = 0, j = 0;
#endif

	INTS = 0X00;
	CLRWDT();

	SET_HIRC(IRCF_8M); // ڲƵѡ8MHz

	Init_GPIO(); // ʼGPIO

	INT0_Init(); // ʼⲿж0

	INT1_Init(); // ʼⲿж1

	WDTCON = 0x15; // 1:32768   Źʱ1/(31000/32768) == 1.05s

	//========================ѭ==================
	while (1)
	{
		CLRWDT(); //  Ź

#if !SLEEPWAKE_EN

		PA5 ^= 1;

#else

		for (j = 0; j < 5; ++j) // ʱ
		{
			i = 65535;
			while (--i)
				;
		}

		Sleep_Pro(); // ˯

#endif
	}
}

/*******************************************************************
;
;: Init_GPIO

;˵:	ʼIO
;
********************************************************************/

void Init_GPIO(void)
{
	ADINA = 0x00; // PAģ/IO 		1:ģ⹦		0:I/O
	ADINC = 0x00; // PCģ/IO 		1:ģ⹦		0:I/O

	CPIOA = 0b00000000; // PA		1:		0:
	CPIOC = 0b00001100; // PC		1:		0:

	PAPHR = 0x00; // PAλ			1:ʹ		0:ֹ
	PAPDR = 0x00; // PAλ			1:ʹ		0:ֹ

	PCPHR = 0x0C; // PCλ			1:ʹ		0:ֹ
	PCPDR = 0x00; // PCλ			1:ʹ		0:ֹ

	PAINTR = 0x00; // PAƽ仯жλ		1:ʹ		0:ֹ

	PORTA = 0x00; // PAȫ"L"
	PORTC = 0x00; // PCȫ"L"
}

//*******************************
//	INT0_Init
//
//	ܣʼⲿж0
//*******************************
void INT0_Init(void)
{
	// INT0
	INT0SEL = 0; // 0½		1

	// λINT0жϱ־
	INT0F = 0;

	// INT0ж
	INT0E = 1;

	// ж
	GIE = 1;
}

//*******************************
//	INT1_Init
//
//	ܣʼⲿж1
//*******************************
void INT1_Init(void)
{
	// INT0
	INT1SEL = 1; // 0½		1

	// λINT0жϱ־
	INT1F = 0;

	// INT0ж
	INT1E = 1;

	// ж
	PEIE = 1;

	// ж
	GIE = 1;
}

//*******************************
//	Sleep_Pro
//
//	ܣ˯ߴ
//*******************************
void Sleep_Pro(void)
{
	/*ر裬Ҫ˯߻Ѻ*/

	ADC_EN = 0;
	PWMA0EN = 0;
	PWMA1EN = 0;
	PWMB0EN = 0;
	PWMB1EN = 0;
	TMR0 = 0;
	TMR1H = 0;
	TMR1L = 0;
	TMR2H = 0;
	TMR2L = 0;
	TMR0EN = 0;
	TMR1ON = 0;
	TMR2ON = 0;
	SWDTEN = 0;

	SET_HIRC(IRCF_1M);
	asm("nop");
	asm("nop");

	SLEEP();

	asm("nop");
	asm("nop");
	SET_HIRC(IRCF_8M);
	asm("nop");
	asm("nop");

	CLRWDT();
	SWDTEN = 1;
	CLRWDT();
}

/*******************************************************************
;
;: ISR
;
;˵:	жϷ
;
********************************************************************/
// void ISR(void) __interrupt 		//YSDCC  жϺ
void interrupt ISR(void) // PICC  жϺ
{
	// жINT0жϱ־λ
	if (INT0F)
	{
		INT0F = 0; // ־

		PA2 ^= 1;
	}

	// жINT1жϱ־λ
	if (INT1F)
	{
		INT1F = 0; // ־

		PA4 ^= 1;
	}
}
