/*******************************************************************
;Company : Yspring ------л㴺Ƽɷ޹˾
;File Name :YS274
;Description :  YS274_PA_AWAKEN_
;˵
;	MCU5V磬PC2LEDPC1ţPA0~PA5ӿأ˳δʹж,PAڵƽ仯ɻMCU
;
;	LEDPC1ţ10ΣȻ˯ߡ
;
;	ıPA״̬ɻMCUѺLEDPC1ţ10ֽ˯ߡ
;
;	MCU˯߹1uA
;
;	ע⣺PAڿڲӵGNDʱеڲ裩
;
*******************************************************************/

#include <YS274.h>
#include "cfg.h"

//-----------------------------------ض----------------

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//---------------------------------------------------------

void Init_Timer0_WDT(void); // ʼtimer0WDT
void Init_Timer1(void);		// ʼtimer1
void Init_Timer2(void);		// ʼtimer2
void Init_GPIO(void);		// ʼIO
void Init_INT(void);		// ʼжϺ
void Sleep_Mode(void);		// ˯ߴ
void Led_Flash(void);
//------------------------------------궨------------------------

#define CLRWDT()       \
	do                 \
	{                  \
		asm("clrwdt"); \
	} while (0)
#define SLEEP()       \
	do                \
	{                 \
		asm("sleep"); \
		asm("NOP");   \
		asm("NOP");   \
		;             \
	} while (0) // asm("clrwdt");asm("clrwdt")

#define TRUE 1
#define FALSE 0

#define T100MS 50 // 100ms = 50 * 2ms
#define T40MS 20  // 40ms = 20 * 2ms

#define SLEEP_LED_ON() (PC1 = 1)  // ָʾƿ
#define SLEEP_LED_OFF() (PC1 = 0) // ָʾƹ

//----------------------------------------------------------

u8 Timer_2ms_ctr; // 100msʱ
u8 Flash_10_ctr;  //
u8 Sleep_ctr;	  // ˯

//-------------------------------------λ-------------------

bit flag_t0 = 0;
bit flag_sleep = 0;
/*******************************************************************
;
;: main
;
;˵:	
;

********************************************************************/
void main(void)
{
	CLRWDT();		   // WDT
	SET_HIRC(IRCF_4M); // ϵͳ

	Init_Timer0_WDT(); // ʼʱ_WDT
	//	Init_Timer1();
	//	Init_Timer2();
	Init_GPIO(); // ʼIO
	Init_INT();	 // ʼж

	//==================================ѭ===========================
	while (1)
	{
		CLRWDT(); //  Ź

		if (TIF == 1) // ʱ0жϱ־ж
		{
			TIF = 0; // T0 Զع Ҫóʼֵ

			PORTC ^= 0x01;	// Timer0 ʱ 2msж	PC0 ȡ
			flag_t0 = TRUE; // ʱ100־1
		}

		if (flag_t0 == TRUE) // ʱ100msж
		{
			flag_t0 = FALSE; // ʱ100ms־0

			Led_Flash(); // ָʾ

			Sleep_Mode(); // ˯ߴ
		}
	}
}

/*******************************************************************
;
;: Led_Flash

;˵:	LED10κ
;
********************************************************************/

void Led_Flash(void)
{
	if (flag_sleep == FALSE)
	{
		Timer_2ms_ctr++;			 // ʱ 1
		if (Timer_2ms_ctr >= T100MS) // 100msж
		{
			Timer_2ms_ctr = 0x00; // ʱ 0

			PORTC ^= 0x04; // Timer2 ʱ100msж	PC2 ȡ

			if (PC2 == 0) //
			{
				Flash_10_ctr++;
				if (Flash_10_ctr >= 10) // 10κMCU ˯
				{
					Flash_10_ctr = 0x00; // ˸

					flag_sleep = TRUE; // ˯߱־ 1
				}
			}
		}
	}
}
/*******************************************************************
;
;: Sleep_Mode

;˵:	MCU˯ߴ
;
********************************************************************/

void Sleep_Mode(void)
{
	if (flag_sleep == TRUE) // жǷ˯
	{
		Sleep_ctr++; // ˯ʱʱ 1
		if (Sleep_ctr >= T40MS)
		{
			Sleep_ctr = 0x00; // ˯ʱʱ 0

			// 272ͬͺŲͬλװMCUͬһžԲ272_sop8ֻװPAڣûPCڣʼ˯ߵҪPCҲǽȥPCδҲ©
			PORTA = 0x00; // PA ȫ"L"
			PORTC = 0x00; // PC ȫ"L"

			// 272˯ ©ע: MCU ϵĬѡⲿο(PC1/VREF) ΪADοѹ˯ǰĳڲο©硣
			//						ʹĬϵⲿοʱPC1Ϊڣߣ˯ʱ45uA ©ڡ
			//			ADS0 = 0x0c;	//
			//			PC1 = 1;		//

			ADS0 = VREFSEL_1024MV; // ѡڲ1.024V

			T1SELEN = 0;
			T2SELEN = 0; // ע:	T1SELENΪ"1"T2SELENΪ"1"ʱMCUһֱڹ״̬޷˯

			SLEEP_LED_OFF(); // ˯ʱ ߣѺ(ָʾǰ ˯/ ״̬)

			PAIE = 1;	   // ʹ PAƽ仯ж
			PAINTR = 0x3f; // PAƽ仯жλ		1:ʹ		0:ֹ
			PORTA = PORTA; // õƽ仯ʱ˯ǰ(д)˿״̬ȻPAIF PAIFᱻظ1 MCUظ ˯
			PAIF = 0;	   // PAƽ仯жϱ־

			SWDTEN = 0;			 //  WDT
			SET_HIRC(IRCF_500K); // ˯֮ǰ ϵͳʱ л	500KHz С 500KHzɴ500KHz--------ｫFoscΪ500KHz
			CLRWDT();
			asm("nop"); // лϵͳʱӡϵNOPָȴʱȶ
			asm("nop");
			asm("nop");

			SLEEP(); // MCU ˯

			CLRWDT(); // MCUѺ  WDT

			// MCUѹ4.5Vʱʹ16MHzΪϵͳʱ 
			SET_HIRC(IRCF_4M); // Ѻ󣬡ϵͳʱӡл衰ʱƵʡ--------ｫFoscΪ4MHz
			asm("nop");		   // лϵͳʱӡϵNOPָȴʱȶ
			asm("nop");
			asm("nop");

			SWDTEN = 1; //  WDT
			CLRWDT();	//  WDT

			SLEEP_LED_ON(); // ˯ʱ ߣѺ(ָʾǰ ˯/ ״̬)

			flag_sleep = FALSE; // ˯߱־
		}
	}
	else
	{
		Sleep_ctr = 0x00; // ˯߼0
	}
}

/*******************************************************************
;
;: ISR
;
;˵:	жϷ
;
;	ж϶ͬһڣֲͬжԴֱж϶Ӧжϱ־ɣȼ֮
;
;
********************************************************************/
// void ISR(void) __interrupt 		//YSDCC  жϺ
void interrupt ISR(void) // PICC  жϺ
{
	// ˳δʹж,ԲжϺPAڵƽ仯ԻMCU
}

/*******************************************************************
;
;: Init_GPIO

;˵:	ʼIO
;
********************************************************************/

void Init_GPIO(void)
{
	ADINA = 0x00; // PAģ/IO 		1:ģ⹦		0:I/O
	ADINC = 0x00; // PCģ/IO 		1:ģ⹦		0:I/O

	CPIOA = 0x3f; // PA			1:		0:
	CPIOC = 0x00; // PC			1:		0:

	PAPHR = 0x3f; // PAλ			1:ʹ		0:ֹ

	PAPDR = 0x00; // PAλ			1:ʹ		0:ֹ

	PCPHR = 0x00; // PCλ			1:ʹ		0:ֹ
	PCPDR = 0x00; // PCλ			1:ʹ		0:ֹ

	PAINTR = 0x3f; // PAƽ仯жλ		1:ʹ		0:ֹ
	PORTA = 0x00;  // PAȫ"L"
	PORTC = 0x00;  // PCȫ"L"
}

/*******************************************************************
;
;: Init_Timer0_WDT

;˵:	ʼTimer0WDT
;
********************************************************************/

void Init_Timer0_WDT(void)
{
	TCS = 0;	 // TMR0ʱԴѡλ		1:PA2/T0CKIźŵ 	0:ڲָʱӣFosc/4
	T0PSDIV_8(); // Timer0ԤƵѡ1:8 8us (Fosc = 4MHz)  (Fcpu = Fosc/4 = 1MHz)
	TMR0 = 6;	 // 250 = 256 - 6 	2ms = 250 * 8us
	TMR0EN = 1;	 // Tiemr0 /ֹͣλ	1:Timer0		0:ֹͣTimer0

	//	WDTDIV_512();
	WDTDIV_32768(); ////ÿŹʱ
	SWDTEN = 1;		// Źʹ
}

/*******************************************************************
;
;: Init_Timer1

;˵:	ʼTimer1
;
********************************************************************/
void Init_Timer1(void)
{
}

/*******************************************************************
;
;: Init_Timer2

;˵:	ʼTimer2
;
********************************************************************/
void Init_Timer2(void)
{
}

/*******************************************************************
;
;: Init_INT

;˵:	ʼ ж
;
********************************************************************/

void Init_INT(void)
{
	INTS = 0x00;  // жؼĴ 
	PIFB0 = 0x00; // ⲿж
	PIFB1 = 0x00; // ⲿж

	PAIE = 1; // ʹ PAƽ仯ж

	TIF = 0; // 嶨ʱжϱ־
	TIS = 1; // ʹ T0ж

	//	PEIE = 1;		//ʹ  ж
	//	GIE = 1;		//ʹ  ж
	GIE = 0; // ֹ  ж	(˳ʹж)
}

//******************************************************************
