/***********************************************************************************
;Company : Yspring ------л㴺Ƽɷ޹˾
;File Name :YS274
;Description :  YS274_PA_INT_AWAKEN_
;˵
;
;	MCU5V磬PC2LEDPA0~PA5ӿأPAڵƽ仯ɻMCU
;
;	ϵLED10ΣȻ˯ߡ
;
;	״̬ıɻMCUжϣѺLED10ֽ˯ߡ
;
;	вضϿMCU˯߹1uA
;
;	ע⣺PAڿڲӵGNDʱеڲ裩
************************************************************************************/

#include <YS274.h>
#include "cfg.h"

//--------------------------------ض------------------------------------

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//--------------------------------------------------------------------------

void Init_Timer0_WDT(void); // ʼtimer0WDT
void Init_Timer1(void);		// ʼtimer1
void Init_Timer2(void);		// ʼtimer2
void Init_GPIO(void);		// ʼIO
void Init_INT(void);		// ʼINT
void Led_Flash(void);		// LED˸
void Sleep_Mode(void);		// ˯ߴ

//--------------------------------궨-------------------------------------------

#define CLRWDT()       \
	do                 \
	{                  \
		asm("clrwdt"); \
	} while (0)
#define SLEEP()       \
	do                \
	{                 \
		asm("sleep"); \
		asm("NOP");   \
		asm("NOP");   \
		;             \
	} while (0) // asm("clrwdt");asm("clrwdt")

#define T100MS 50 // 100ms = 50 * 2ms
#define T40MS 20  // 40ms = 20 * 2ms

#define SLEEP_LED_ON() (PC1 = 1)  // LED ON
#define SLEEP_LED_OFF() (PC1 = 0) // LED OFF

//-------------------------------------------------------------------------

u8 Timer_2ms_ctr; // 2ms
u8 Flash_10_ctr;  // ˸

u8 Sleep_ctr; // ˯߼

//-------------------------------λ----------------------------------------
bit flag_t0 = 0;	// 2ms־
bit flag_sleep = 0; // ˯߱־
/**********************************************************************************
;
;: main
;
;˵:	
;
;
*********************************************************************************/
void main(void)
{
	CLRWDT(); // 忴Ź

	SET_HIRC(IRCF_4M); // ڲƵѡ4MHz

	Init_Timer0_WDT(); // ʼtimer0wdt
	//	Init_Timer1();              //ʼtimer1
	//	Init_Timer2();              //ʼtimer2
	Init_GPIO(); // ʼIO
	Init_INT();	 // ʼINT

	//==========================ѭ===============================================
	while (1)
	{
		CLRWDT(); //  Ź

		if (flag_t0 == 1) // 2msж
		{
			flag_t0 = 0;  // 2ms־
			Led_Flash();  // LED˸
			Sleep_Mode(); // ˯ߴ
		}
	}
}

/*******************************************************************************
;
;: Led_Flash

;˵:	LED10κ
;
*******************************************************************************/

void Led_Flash(void)
{
	if (flag_sleep == 0) // ˯ж
	{
		Timer_2ms_ctr++;			 // 2ms
		if (Timer_2ms_ctr >= T100MS) // 100ms
		{
			Timer_2ms_ctr = 0x00; // 0

			PORTC ^= 0x04; // Timer2 ʱ100msж	PC2 ȡ
			if (PC2 == 0)
			{
				Flash_10_ctr++;			// ˸ 1
				if (Flash_10_ctr >= 10) // 10κMCU ˯
				{
					Flash_10_ctr = 0x00; // ˸ 0

					flag_sleep = 1; // ˯߱־1
				}
			}
		}
	}
}

/*******************************************************************************
;
;: Sleep_Mode

;˵:	MCU˯ߴ
;
*******************************************************************************/

void Sleep_Mode(void) // ˯ߴ
{
	if (flag_sleep == 1) // ˯ж
	{
		Sleep_ctr++; // ˯߼ 1
		if (Sleep_ctr >= T40MS)
		{
			Sleep_ctr = 0x00; // ˯߼0

			// 272ͬͺŲͬλװMCUͬһžԲ272_sop8ֻװPAڣûPCڣʼ˯ߵҪPCҲǽȥPCδҲ©
			PORTA = 0x00; // PA ȫ"L"
			PORTC = 0x00; // PC ȫ"L"

			// 272˯ ©ע:  	MCU ϵĬѡⲿο(PC1/VREF) ΪADοѹ˯ǰĳڲο©硣
			//						ʹĬϵⲿοʱPC1Ϊڣߣ˯ʱ45uA ©ڡ
			//			REFSEL_PC1();	    //
			//			PC1 = 1;

			ADS0 = VREFSEL_1024MV; // ѡڲ1.024V

			T1SELEN = 0;
			T2SELEN = 0; // ע:	T1SELENΪ"1"T2SELENΪ"1"ʱMCUһֱڹ״̬޷˯

			SLEEP_LED_OFF(); // ˯ʱ ߣѺ(ָʾǰ ˯/ ״̬)

			PAIE = 1;
			PAINTR = 0x3f; // PAƽ仯жλ		1:ʹ		0:ֹ
			PORTA = PORTA; // õƽ仯ʱ˯ǰȡ˿״̬
			PAIF = 0;

			SWDTEN = 0;			 //  WDT
			SET_HIRC(IRCF_500K); // ˯֮ǰ ϵͳʱ л	500KHz С 500KHzɴ500KHz--------ｫFoscΪ500KHz
			CLRWDT();
			asm("nop"); // лϵͳʱӡϵNOPָȴʱȶ
			asm("nop");
			asm("nop");

			SLEEP(); // MCU ˯

			CLRWDT(); // MCUѺ  WDT

			// MCUѹ4.5Vʱʹ16MHzΪϵͳʱ 
			SET_HIRC(IRCF_4M); // Ѻ󣬡ϵͳʱӡл衰ʱƵʡ--------ｫFoscΪ4MHz
			asm("nop");		   // лϵͳʱӡϵNOPָȴʱȶ
			asm("nop");
			asm("nop");

			SWDTEN = 1; //  WDT
			CLRWDT();	// WDT

			SLEEP_LED_ON(); // ˯ʱ ߣѺ(ָʾǰ ˯/ ״̬)

			flag_sleep = 0; // ˯߱־0
		}
	}
	else
	{
		Sleep_ctr = 0x00; // ˯߱־
	}
}

/*****************************************************************************
;
;: ISR
;
;˵:	жϷ
;
;	ж϶ͬһڣֲͬжԴֱж϶Ӧжϱ־ɣȼ֮

*****************************************************************************/
void interrupt ISR(void) // PICC  жϺ
{

	if (TIF == 1) // tmr0жж
	{
		TIF = 0; // T0жϱ־0

		PORTC ^= 0x01; // Timer0 ʱ 2msж	PC0 ȡ
		flag_t0 = 1;   // 2ms־ 1
	}

	if (PAIF)
	{
		// ʹ˵ƽ仯жϣж˳ǰȡPA ˿״̬PAIFᷴж
		PORTA = PORTA; // PORTA
		PAIF = 0;	   // ƽ仯жϱ־0
	}

	/*
	if(TMR1IF == 1)
	{
		TMR1IF = 0;
	}

	if(TMR2IF == 1)
	{
		TMR2IF = 0;
	}
	*/
}

/****************************************************************************
;
;: Init_GPIO

;˵:	ʼIO
;
****************************************************************************/

void Init_GPIO(void)
{
	ADINA = 0x00; // PAģ/IO 		1:ģ⹦		0:I/O
	ADINC = 0x00; // PCģ/IO 		1:ģ⹦		0:I/O

	CPIOA = 0x3f; // PA			1:		0:
	CPIOC = 0x00; // PC			1:		0:

	PAPHR = 0x3f; // PAλ			1:ʹ		0:ֹ

	PAPDR = 0x00; // PAλ			1:ʹ		0:ֹ

	PCPHR = 0x00; // PCλ			1:ʹ		0:ֹ
	PCPDR = 0x00; // PCλ			1:ʹ		0:ֹ

	PAINTR = 0x3f; // PAƽ仯жλ		1:ʹ		0:ֹ
	PORTA = 0x00;  // PAȫ"L"
	PORTC = 0x00;  // PCȫ"L"
}

/**************************************************************************
;
;: Init_Timer0_WDT

;˵:	ʼTimer0WDT
;
**************************************************************************/

void Init_Timer0_WDT(void)
{
	TCS = 0;	 // TMR0ʱԴѡλ		1:PA2/T0CKIźŵ 	0:ڲָʱӣ Fosc/4
	T0PSDIV_8(); // Timer0ԤƵѡ1:8 8us (Fosc = 4MHz)  (Fcpu = Fosc/4 = 1MHz)
	TMR0 = 6;	 // 250 = 256 - 6 	2ms = 250 * 8us
	TMR0EN = 1;	 // Tiemr0 /ֹͣλ	1:Timer0		0:ֹͣTimer0

	//	WDTDIV_512();
	WDTDIV_32768(); // WDT
	SWDTEN = 1;		// ʹܿŹ
}

/**************************************************************************
;
;: Init_Timer1

;˵:	ʼTimer1
;
**************************************************************************/
void Init_Timer1(void)
{
}

/**************************************************************************
;
;: Init_Timer2

;˵:	ʼTimer2
;
**************************************************************************/
void Init_Timer2(void)
{
}

/**************************************************************************
;
;: Init_INT

;˵:	ʼ ж
;
**************************************************************************/

void Init_INT(void)
{

	INTS = 0x00;  // жؼĴ 
	PIFB0 = 0x00; // жؼĴ 
	PIFB1 = 0x00; // жؼĴ 

	PAIE = 1; // ʹ PAƽ仯ж

	TIF = 0; // T0жϱ־0
	TIS = 1; // ʹ T0ж

	//	PEIE = 1;		//ʹ  ж
	GIE = 1; // ʹ  ж
}
