/***********************************************************************************
;Company : Yspring ------л㴺Ƽɷ޹˾
;File Name :YS274
;Description :  YS274_AD_
;˵ɼAN2ͨADֵѹ2.02VʱʹPA4ߵƽ
                              ѹС2VʱʹPA4͵ƽ
***********************************************************************************/

#include <YS274.h>
#include "cfg.h"
//-----------------------------------ض--------------------------------

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//-------------------------------------------------------------------------


void Init_Timer0_WDT(void); //timer0WDTʼ
void Init_Timer1(void);     //timer1ʼ
void Init_Timer2(void);     //timer2ʼ
void Init_GPIO(void);       //IOʼ
void Init_INT(void);        //жϳʼ
void Init_ADC(void);        //ADʼ
void delay(unsigned char i);//ʱ

u16 Get_ADC_Result(u8 CHx ,u8 REFx);//ADת

//------------------------------------궨--------------------------------------
#define T500ms	500

#define CLRWDT()	do {asm("clrwdt");} while (0)
#define SLEEP() 	do {asm("sleep");  asm("NOP"); asm("NOP"); ;} while (0)//asm("clrwdt");asm("clrwdt")

//------------------------------------------------------------------------
u16 adc_res;                //ADC
u16 adc_vss;
u16 adc_temp;               //ADC
//-----------------------------------λ---------------------------------------
bit flag_t0=0;              //־λ

/*********************************************************************************
;: main 
;˵:	
*********************************************************************************/
void main(void)         
{
	CLRWDT();          //忴Ź

	SET_HIRC(IRCF_4M); //ڲƵѡ4MHz


	Init_GPIO();       //IOʼ

	Init_Timer0_WDT(); //ʼʱ
//	Init_Timer1();
//	Init_Timer2();

	Init_INT();        //ʼж

	Init_ADC();        //ʼADC
	
//========================ѭ==================================================
	while(1)
	{
		CLRWDT();      // Ź 
			
		if(flag_t0 == 1)//2ms־ж
		{
			flag_t0 = 0;//2ms־0
			
			adc_temp = Get_ADC_Result(ANCHSEL_AN2,VREFSEL_4096MV) - Get_ADC_Result(ANCHSEL_VSS,VREFSEL_4096MV);//ɼͨAN2ADֵ - VssͨADֵʹADֵ׼ȷЩ

			if(adc_temp >= 2020)		//AD ڵѹ2.02V	 
				PA4 = 1;				
			else if(adc_temp < 2000)	//AD ڵѹ2V	 
				PA4 = 0;			
		}	
	}
}

/*********************************************************************************
;: Get_ADC_Result
;
;˵: ȡAD12λAD(0~4095)
;				
;ڲ:  ѡͨ CHx ,ѡοѹ REFx
;
;ֵ: 	adc_res
;
*********************************************************************************/
u16 Get_ADC_Result(u8 CHx ,u8 REFx)
{
	u8 i = 0;               //ʱ
	u16 temp =0,adsum=0;    //ʱ
	ADS0 = 0;               //
	ADS0 = ADS0 | CHx | REFx;	//ģͨѡ
	ADC_EN = 1;             // ADģ 	
	
	delay(50);              //ʱ200us		//ıοѹ ADģ  ʱ200us
	
	adsum =0;               //Ĵ0
	
	for(i=0;i<8;i++)
	{
		BUSY = 1;			//AD ʼת
		while(BUSY);		//ȴAD ת  
		temp = ADRESH;	    //(0000 xxxx)ȡ12λAD ֽڼĴ(4λΪ04 λֵЧ)   //ADҶ	
		temp <<= 8;		    //(0000 xxxx 0000 0000)
		temp += ADRESL;	    //(0000 xxxx xxxx xxxx)ȡ12λAD ֽڼĴֵadc_res 
		
		adsum+=temp;        //
	}

	temp=adsum>>3;          //3λƽ

	ADC_EN = 0;				//رADģ ʡ
	
	return(temp);           //ADֵ
}
/**********************************************************************************
;
;: Init_ADC

;˵:	ʼAD
;
**********************************************************************************/
void Init_ADC(void)
{
	
	CPIOA = 04;
	ADCHSET_PA2AN2();	//ADͨ

	ADFM = 1;			//AD Ҷ룬λ
	ADSCKDIV_16();		//ADʱԤƵѡ
	ADSTASEL_BUZY();	//ADתģʽѡ


	//ע: ϵʼ ˯߻ѺرADģ   ֹĳЩӦõADģ쳣
	ADC_EN = 0;			//ر ADģ
}

/*******************************************************************
;
;: delay 
;
;˵:	ʱӳ
;
********************************************************************/

void delay(unsigned char i)
{
	while(i--);			//ʱ
}	

/*******************************************************************
;
;: ISR 
;
;˵:	жϷ
;
********************************************************************/
//void ISR(void) __interrupt 		//YSDCC  жϺ
void interrupt ISR(void)		//PICC  жϺ
{
	
	if(TIF == 1)        //tmr0ж      
	{
		TIF = 0;        //T0 Զع Ҫóʼֵ
		
		PORTC ^= 0x01;  //Timer0 ʱ 2msж	PC0 ȡ
		flag_t0 = 1; //2ms־
	}
	
}

/*******************************************************************
;
;: Init_GPIO

;˵:	ʼIO
;
********************************************************************/

void Init_GPIO(void)
{
	ADINA = 0x00;	//PAģ/IO 		1:ģ⹦		0:I/O
	ADINC = 0x00;	//PCģ/IO 		1:ģ⹦		0:I/O

	CPIOA = 0b00001000;	//PA		1:		0:
	CPIOC = 0b00000000;	//PC		1:		0:
	
	PAPHR = 0x00;	//PAλ			1:ʹ		0:ֹ
	PAPDR = 0x00;	//PAλ			1:ʹ		0:ֹ
	
	PCPHR = 0x00;	//PCλ			1:ʹ		0:ֹ
	PCPDR = 0x00;	//PCλ			1:ʹ		0:ֹ
		
	PAINTR = 0x00;	//PAƽ仯жλ		1:ʹ		0:ֹ
	
	PORTA = 0x00;	//PAȫ"L"
	PORTC = 0x00;	//PCȫ"L"
	
}

/*******************************************************************
;
;: Init_Timer0_WDT

;˵:	ʼTimer0WDT
;
********************************************************************/

void Init_Timer0_WDT(void)
{
	TCS = 0;		//TMR0ʱԴѡλ		1:PA2/T0CKIźŵ		0:ڲָʱӣ Fosc/4
	T0PSDIV_8();	//Timer0ԤƵѡ1:8	8us	(Fosc = 4MHz)  (Fcpu = Fosc/4 = 1MHz)
	TMR0 = 6;		//250 = 256 - 6		2ms = 250 * 8us	
	TMR0EN = 1;		//Tiemr0 /ֹͣλ	1:Timer0		0:ֹͣTimer0
	
//	WDTDIV_512();
	WDTDIV_32768(); //ÿŹʱ
	SWDTEN = 1;		//ʹܿŹ
}


/*******************************************************************
;
;: Init_Timer1

;˵:	ʼTimer1
;
********************************************************************/
void Init_Timer1(void)
{
	

}


/*******************************************************************
;
;: Init_Timer2

;˵:	ʼTimer2
;
********************************************************************/
void Init_Timer2(void)
{

}


/*******************************************************************
;
;: Init_INT

;˵:	ʼ ж
;
********************************************************************/

void Init_INT(void)
{
	INTS = 0x00;	//жؼĴ 
	
	TIF = 0;		//tmr0жϱ־0
	TIS = 1;		//ʹ T0ж
	
	GIE = 1;		//ʹ  ж
}




