/**********************************************************************
;Company : Yspring ------л㴺Ƽɷ޹˾
;File Name:YS274
;Description :  YS274_WDT_AWAKEN_
;˵
;			MCU5V磬PA5LED2sѭ
;			˯ߣ˯ʱLED
;			˯ʱWDTWDTʱ4.2s˯߻ѡ
;			MCU˯߹1.2uA
**********************************************************************/

#include <YS274.h>
#include "cfg.h"

//-----------------------ض--------------------------------

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//---------------------------------------------------------------

void Init_Timer0_WDT(void); // ʼtimer0WDT
void Init_Timer1(void);		// ʼtimer1
void Init_Timer2(void);		// ʼtimer2
void Init_GPIO(void);		// ʼIO
void Init_INT(void);		// ʼINT

//-------------------------궨--------------------------------------

#define CLRWDT()       \
	do                 \
	{                  \
		asm("clrwdt"); \
	} while (0)
#define SLEEP()       \
	do                \
	{                 \
		asm("sleep"); \
		asm("NOP");   \
		asm("NOP");   \
		;             \
	} while (0) // asm("clrwdt");asm("clrwdt")

#define T2S 20 // 2s = 20 * 100ms

//-------------------------------------------------------------

u8 Timer_100ms_ctr; // 100ms

//-------------------------λ----------------------------------

bit flag_t2 = 0; // 100msжϱ־

/**********************************************************************
;
;: main
;
;˵:	
;
;
********************************************************************/
void main(void)
{
	CLRWDT(); // 忴Ź

	SET_HIRC(IRCF_4M); // ڲƵѡ4MHz

	Init_Timer0_WDT(); // ʼtimer0WDT
	Init_Timer1();	   // ʼtimer1
	Init_Timer2();	   // ʼtimer2
	Init_GPIO();	   // ʼIO
	Init_INT();		   // ʼINT

	//==========================================ѭ
	while (1)
	{
		CLRWDT(); //  Ź

		if (flag_t2 == 1) // 100msж
		{
			flag_t2 = 0; // 100ms־

			PORTA ^= 0x20; // Timer2 ʱ100msж	PA5 ȡ

			Timer_100ms_ctr++;			// 100ms
			if (Timer_100ms_ctr >= T2S) // 2sж
			{
				Timer_100ms_ctr = 0x00; // 0

				PORTA = 0x00; // PA ȫ"L"
				PORTC = 0x00; // PC ȫ"L"

				SET_HIRC(IRCF_500K); // ڲƵѡ500k			//˯֮ǰ ϵͳʱ л	500KHz С 500KHzɴ500KHz--------ｫFoscΪ500KHz
				CLRWDT();
				asm("nop"); // лϵͳʱӡϵNOPָȴʱȶ
				asm("nop");
				asm("nop");

				SLEEP(); // MCU ˯

				CLRWDT(); // MCUѺ  WDT

				// MCUѹ4.5Vʱʹ16MHzΪϵͳʱ 
				SET_HIRC(IRCF_4M); // ڲƵѡ4MHz			//Ѻ󣬡ϵͳʱӡл衰ʱƵʡ--------ｫFoscΪ4MHz
				asm("nop");		   // лϵͳʱӡϵNOPָȴʱȶ
				asm("nop");
				asm("nop");

				PORTA ^= 0x20; // Timer2 ʱ100msж	PA5 ȡ
			}
		}
	}
}

/*******************************************************************
;
;: ISR
;
;˵:	жϷ
;
********************************************************************/
void interrupt ISR(void) // PICC  жϺ
{

	if (TIF == 1) // TMR0жж
	{
		TIF = 0; // TMR0жϱ־0
	}

	if (TMR1IF == 1) // timer1жж
	{
		TMR1IF = 0; // timer1жϱ־0
	}

	if (TMR2IF == 1) // timer2жж
	{
		TMR2IF = 0; // timer2жϱ־0

		TMR2ON = 0;	  // ֹtimer2ʱ
		TMR2H = 0x3c; // 15536 = 65536 - 50000	(0x3cb0 = 15536)
		TMR2L = 0xb0; // 100ms = 50000 * 2us
		TMR2ON = 1;	  // ʹtimer2ʱ

		flag_t2 = 1; // 100ms־1
	}
}

/*******************************************************************
;
;: Init_GPIO

;˵:	ʼIO
;
********************************************************************/

void Init_GPIO(void)
{
	ADINA = 0x00; // PAģ/IO 		1:ģ⹦		0:I/O
	ADINC = 0x00; // PCģ/IO 		1:ģ⹦		0:I/O

	CPIOA = 0b00000000; // PA		1:		0:
	CPIOC = 0b00000000; // PC		1:		0:

	PAPHR = 0x00; // PAλ			1:ʹ		0:ֹ
	PAPDR = 0x00; // PAλ			1:ʹ		0:ֹ

	PCPHR = 0x00; // PCλ			1:ʹ		0:ֹ
	PCPDR = 0x00; // PCλ			1:ʹ		0:ֹ

	PAINTR = 0x00; // PAƽ仯жλ		1:ʹ		0:ֹ

	PORTA = 0x00; // PAȫ"L"
	PORTC = 0x00; // PCȫ"L"
}

/*******************************************************************
;
;: Init_Timer0_WDT

;˵:	ʼTimer0WDT
;
********************************************************************/

void Init_Timer0_WDT(void)
{
	//	TCS = 0;		//TMR0ʱԴѡλ		1:PA2/T0CKIźŵ		0:ڲָʱӣ Fosc/4
	//	TMR0 = 6;		//
	//	TMR0EN = 0;		//Tiemr0 /ֹͣλ	1:Timer0		0:ֹͣTimer0

	WDTPSDIV_2();	// 8λԤƵWDTԤƵѡ1:2
	WDTDIV_65536(); // WDT
	SWDTEN = 1;		// ʹWDTOPTION disable WDTʱЧ
}
/*******************************************************************
;
;: Init_Timer1

;˵:	ʼTimer1
;
********************************************************************/
void Init_Timer1(void)
{
}
/*******************************************************************
;
;: Init_Timer2

;˵:	ʼTimer2
;
********************************************************************/
void Init_Timer2(void)
{

	T2SELEN = 0; // Timer2 ʱԴѡλ					0: Timer2 ʱԴTMR2CSλȷ
	//	T2SELEN = 1;	//Timer2 ʱԴѡλ					1: Timer2 ʱԴ T2FOSCλȷ

	T2FOSC = 0; // Timer2 ʱԴѡڲʱʹλ 		0: Timer2 ʱԴѡڲ " ʱ " 	( T2SELEN = 1ʱ)
	//	T2FOSC = 1; //Timer2 ʱԴѡڲʱʹλ 	1: Timer2 ʱԴѡڲ " ʱ " ( T2SELEN = 1ʱ)

	T2GINV = 0; // Timer2ſطתλ					0: Timer2ſΪ͵ƽЧſΪ͵ƽʱTimer2
	//	T2GINV = 1;		//Timer2ſطתλ				1: Timer2ſΪߵƽЧſΪߵƽʱTimer2

	TMR2GE = 0; // Timer2ſʹλ					0: Timer2
	//	TMR2GE = 1;		//Timer2ſʹλ				1: Timer2Timer2ſزʱ

	T2PSDIV_8(); // Timer2ʱԤƵѡ1:8	( Fosc = 4MHz  __ T = 2us)

	T2SYNC = 0; // Timer2ⲿʱͬλ		0: ͬⲿʱ
	//	T2SYNC = 1;		//Timer2ⲿʱͬλ		1: ͬⲿʱ

	TMR2CS = 0; // Timer2ʱԴѡλ			0: ڲʱӣSYS_CLK
	//	TMR2CS = 1;		//Timer2ʱԴѡλ			1: T12CK1ţأⲿʱ

	T2OSCEN = 0; // LPʹܿλ			0:  LPر
	//	T2OSCEN = 1;	//LPʹܿλ			1:  LPʹTimer2ʱ

	TMR2H = 0x3c; // 15536 = 65536 - 50000	(0x3cb0 = 15536)
	TMR2L = 0xb0; // 100ms = 50000 * 2us

	TMR2ON = 1; // Timer2/ֹͣλ		1:  Timer2		0: ֹͣTimer2
}

/*******************************************************************
;
;: Init_INT

;˵:	ʼ ж
;
********************************************************************/

void Init_INT(void)
{
	INTS = 0x00;  // жؼĴ 
	PIFB0 = 0x00; // жؼĴ 
	PIFB1 = 0x00; // жؼĴ 

	TMR2IF = 0;
	TMR2IE = 1; // ʹ  T2ж		õ T2ж ͬʱʹ T2жϡжϡж

	PEIE = 1; // ʹ  ж
	GIE = 1;  // ʹ  ж
}

//*******************************************************************
